% Sebastian Fossati
% 12/2011
% University of Alberta
% 
% PURPOSE: 


function [SS] = ss_model(parm)

gamma1 = parm(1,1);
gamma2 = parm(2,1);
gamma3 = parm(3,1);
gamma4 = parm(4,1);

phi1 = parm(5,1);
phi2 = parm(6,1);

psi11 = parm(7,1);
psi12 = parm(8,1);
psi21 = parm(9,1);
psi22 = parm(10,1);
psi31 = parm(11,1);
psi32 = parm(12,1);
psi41 = parm(13,1);
psi42 = parm(14,1);

sig21 = parm(15,1);
sig22 = parm(16,1);
sig23 = parm(17,1);
sig24 = parm(18,1);


% Place parameters into SS matrices

% Measurement Equation: y(t) = H*b(t) + e, e~N(0,R)
SS.H = [gamma1,0,1,0,0,0,0,0,0,0;...
        gamma2,0,0,0,1,0,0,0,0,0;...
        gamma3,0,0,0,0,0,1,0,0,0;...
        gamma4,0,0,0,0,0,0,0,1,0];
SS.R = [0,0,0,0;0,0,0,0;0,0,0,0;0,0,0,0];

% Transition Equation: b(t) = F*b(t-1) + v, v~N(0,Q)
SS.F = [phi1,phi2,0,0,0,0,0,0,0,0;...
        1,0,0,0,0,0,0,0,0,0;...
        0,0,psi11,psi12,0,0,0,0,0,0;...
        0,0,1,0,0,0,0,0,0,0;...        
        0,0,0,0,psi21,psi22,0,0,0,0;...
        0,0,0,0,1,0,0,0,0,0;...        
        0,0,0,0,0,0,psi31,psi32,0,0;...
        0,0,0,0,0,0,1,0,0,0;...
        0,0,0,0,0,0,0,0,psi41,psi42;...
        0,0,0,0,0,0,0,0,1,0];
SS.Q = [1,0,0,0,0,0,0,0,0,0;...
        0,0,0,0,0,0,0,0,0,0;...
        0,0,sig21,0,0,0,0,0,0,0;...
        0,0,0,0,0,0,0,0,0,0;...
        0,0,0,0,sig22,0,0,0,0,0;...
        0,0,0,0,0,0,0,0,0,0;...
        0,0,0,0,0,0,sig23,0,0,0;...
        0,0,0,0,0,0,0,0,0,0;...
        0,0,0,0,0,0,0,0,sig24,0;...
        0,0,0,0,0,0,0,0,0,0];

return;
